include "Vram.inc"
include "VVram.inc"

ext Chars_, Ascii_
ext VVram_

VramTop equ Vram+VramRowSize*0
CharHeight equ 6

dseg
Backup: defs VVramWidth*VVramHeight

; void ClearScreen();
cseg
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*64
        do
            ld (hl),0aah
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop hl | pop af
ret


CharPtrDe:
    push hl
        ld l,a
        ld h,0
        ld e,l
        ld d,h
        add hl,hl ;*2
        add hl,de ;*3
        ld de,Chars_
        add hl,de
        ex de,hl
    pop hl
ret


; ptr<byte> Put(ptr<byte> pVram, byte c);
cseg
Put_: public Put_
    push af | push hl | push de | push bc
        ld a,e
        call CharPtrDe
        ld bc,VramWidth
        ld a,(de) | inc de
        ld (hl),a | add hl,bc
        ld a,(de) | inc de
        ld (hl),a | add hl,bc
        ld a,(de)
        ld (hl),a
    pop bc | pop de | pop hl | pop af
    inc hl
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,Backup
        exx
            ld hl,VramTop
        exx
        ld c, VVramHeight
        do
            ld b,VVramWidth
            do 
                ld a,(de)
                inc de
                cp (hl)
                if nz
                    ld (hl),a
                    exx
                        call CharPtrDe
                        ld bc,VramWidth
                        ld a,(de) | inc de
                        ld (hl),a | add hl,bc
                        ld a,(de) | inc de
                        ld (hl),a | add hl,bc
                        ld a,(de)
                        ld (hl),a
                        ld bc,1-VramWidth*2
                        add hl,bc
                    exx
                else
                    exx
                        inc hl
                    exx
                endif
                inc hl
            dwnz
            exx
                ld bc,VramWidth*3-VVramWidth
                add hl,bc
            exx
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb " -0123456789ABCDEFGHIKMNOPRSTUVXY"
PrintC_: public PrintC_
    push af | push hl | push de | push bc
        push hl
            ld bc,33*256
            ld hl,CharTable
            ld a,e
            do
                cp (hl)
                jr z,PrintC_break
                inc hl
                inc c
            dwnz
            ld c,0
            PrintC_break:
            ld a,c
        pop hl
        ex de,hl
            ld l,a
            ld h,0
            add hl,hl ; *2
            ld c,l | ld b,h
            add hl,hl ; *4
            add hl,bc ; *6
            ld bc,Ascii_
            add hl,bc
        ex de,hl
        ld bc,VramWidth
        ld a,CharHeight
        do
            ex af,af'
                ld a,(de) | inc de
                ld (hl),a
            ex af,af'
            add hl,bc
            dec a
        while nz | wend
    pop bc | pop de | pop hl | pop af
    inc hl
ret
